18
08/09
Run ZNC at boot with an init script
I’m using ZNC on a Debian GNU/Linux server as irc bouncer. One thing that always bothered me was, that ZNC was not started by default when the server was restarted. This is due to the design to be started by a user. Since I don’t wanted to run it with an existing user on this server nor to add a new user which is capable of logging in to the server I’ve set up ZNC to run daemonized by a designated system user.
How?
- Install znc as normal.
apt-get install znc
- Configure znc as normal with your normal user account but don’t start it at the end of the configuration.
znc --makeconf
- Substitute to root and create a new configuration directory for znc in /etc and move your newly created configuration to this directory. After this you can delete the /home/$USER/.znc diretory.
mkdir /etc/znc mv /home/$USER/.znc/* /etc/znc/ rm -R /home/$USER/.znc
- Add a new systemgroup and -user for znc.
addgroup --system znc adduser --system --no-create-home --ingroup znc znc
- Set the appropriate rights for the configuration directory.
chown -R znc:znc /etc/znc
- Now you’ll need to create an init script for znc. You can either use the /etc/init.d/skeleton as base and rewrite it to your needs or you can take my init script and place it as znc in /etc/init.d/.
#! /bin/sh ### BEGIN INIT INFO # Provides: znc # Default-Start: 2 3 4 5 # Default-Stop: 0 1 6 # Short-Description: znc initscript # Description: This is the init-Script for znc. ### END INIT INFO # Author: Henner M. Kruse # # Please remove the "Author" lines above and replace them # with your own name if you copy and modify this script. # Do NOT "set -e" # PATH should only include /usr/* if it runs after the mountnfs.sh script PATH=/sbin:/usr/sbin:/bin:/usr/bin DESC="znc, an advanced modular IRC bouncer" NAME=znc DAEMON=/usr/bin/$NAME DAEMON_ARGS="-d /etc/znc" PIDFILE=/var/run/$NAME.pid SCRIPTNAME=/etc/init.d/$NAME USER=znc GROUP=znc # Exit if the package is not installed [ -x "$DAEMON" ] || exit 0 # Read configuration variable file if it is present [ -r /etc/default/$NAME ] && . /etc/default/$NAME # Load the VERBOSE setting and other rcS variables . /lib/init/vars.sh # Define LSB log_* functions. # Depend on lsb-base (>= 3.0-6) to ensure that this file is present. . /lib/lsb/init-functions # # Function that starts the daemon/service # do_start() { # Return # 0 if daemon has been started # 1 if daemon was already running # 2 if daemon could not be started start-stop-daemon --start --quiet --chuid $USER:$GROUP --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \ || return 1 start-stop-daemon --start --quiet --chuid $USER:$GROUP --pidfile $PIDFILE --exec $DAEMON -- \ $DAEMON_ARGS \ || return 2 # Add code here, if necessary, that waits for the process to be ready # to handle requests from services started subsequently which depend # on this one. As a last resort, sleep for some time. } # # Function that stops the daemon/service # do_stop() { # Return # 0 if daemon has been stopped # 1 if daemon was already stopped # 2 if daemon could not be stopped # other if a failure occurred start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --chuid $USER:$GROUP --pidfile $PIDFILE --name $NAME RETVAL="$?" [ "$RETVAL" = 2 ] && return 2 # Wait for children to finish too if this is a daemon that forks # and if the daemon is only ever run from this initscript. # If the above conditions are not satisfied then add some other code # that waits for the process to drop all resources that could be # needed by services started subsequently. A last resort is to # sleep for some time. start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --chuid $USER:$GROUP --exec $DAEMON [ "$?" = 2 ] && return 2 # Many daemons don't delete their pidfiles when they exit. rm -f $PIDFILE return "$RETVAL" } # # Function that sends a SIGHUP to the daemon/service # do_reload() { # # If the daemon can reload its configuration without # restarting (for example, when it is sent a SIGHUP), # then implement that here. # start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --chuid $USER:$GROUP --name $NAME return 0 } case "$1" in start) [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME" do_start case "$?" in 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;; 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;; esac ;; stop) [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME" do_stop case "$?" in 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;; 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;; esac ;; #reload|force-reload) # # If do_reload() is not implemented then leave this commented out # and leave 'force-reload' as an alias for 'restart'. # #log_daemon_msg "Reloading $DESC" "$NAME" #do_reload #log_end_msg $? #;; restart|force-reload) # # If the "reload" option is implemented then remove the # 'force-reload' alias # log_daemon_msg "Restarting $DESC" "$NAME" do_stop case "$?" in 0|1) do_start case "$?" in 0) log_end_msg 0 ;; 1) log_end_msg 1 ;; # Old process is still running *) log_end_msg 1 ;; # Failed to start esac ;; *) # Failed to stop log_end_msg 1 ;; esac ;; *) #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2 echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2 exit 3 ;; esac : - Now it’s time to run znc with this script. But first you’ll need to make it executable.
chmod +x /etc/init.d/znc /etc/init.d/znc start
You’ll be asked two questions at the first run. Just answer them and they’ll be gone the next time.
[ ?? ] Would you like to create a new pem file? (yes/no) [yes]: yes [ ?? ] hostname of your shell (including the '.com' portion): domain.com
- Now let’s just check if znc is running fine and with the correct user.
ps -aux | grep znc
This should produce an output like this:
znc 26501 0.0 0.5 5864 1680 ? Ss 10:06 0:00 /usr/bin/znc -d /etc/znc
- If your ZNC daemon started correctly, you can tell your system to start it when your system starts with the following command
update-rc.d znc defaults
LeXa
2009/10/13
14:59
Thank’s great how-to !
I run now on ZNC in daemon mode !
LeXa(Quote)
Surrogard
2009/10/23
13:40
Great tutorial, saved much work for me.
Perhaps you should mention to call “update-rc.d znc defaults” after all these steps to install the links for the runlevels.
Just for guys not at an advanced linux console level
Surrogard(Quote)
skaven
2009/10/26
09:44
Thanks. I’ve added one last step for this.
skaven(Quote)
wildekek
2010/01/21
01:37
Works like a charm on Ubuntu 9.10 (Karmic), thanks a bunch, really appreciate it!
wildekek(Quote)
opcow
2010/02/28
17:26
I was running znc as a user with a home directory, but this seemed like a better way to go. However, I have two problems using this setup.
The first problem is that /var/run isn’t writable by znc so it fails to write its pid file. I made a znc directory inside /var/run with the appropriate permissions which seems fine.
The second problem is that all my users are stuck with the same ident (‘znc’ or whatever I spoof in oident.conf) or a randomized ident since there is no $HOME directory for ISpoof to write to. Not so fine.
opcow(Quote)
slap
2010/07/25
18:36
This is not working as of 0.92
slap(Quote)
slap
2010/07/25
19:43
I had to change /usr/bin to /usr/local/bin
Also, how would i go about getting oidentd to work with this?
slap(Quote)
skaven
2010/07/25
20:20
Just configure oidentd as usual and put the .oidentd.conf in /etc/znc, afterwards point the ISpoofFile-config-line in the znc.conf to this file.
skaven(Quote)
slap
2010/07/25
23:49
Just to clarify here. /etc/znc or /etc/znc/configs ?
slap(Quote)
skaven
2010/07/26
00:46
You can also put it to “/this/is/a/totally/awesome/path/for/my/.oident.conf”. Put it whereever you want to as long as you point your znc.conf to the correct path.
skaven(Quote)
slap
2010/07/26
01:24
Thanks for clearing that up. How ever, it just wont work for me, it insists on using znc for ident. My current oidentd.conf in /etc/znc looks like this;
default {
default {
allow spoof
allow spoof_all
allow spoof_privport
allow random_numeric
allow numeric
allow hide
}
}
user “znc” {
default {
}
}
Appricaite your time to help.
slap(Quote)
slap
2010/07/26
20:47
I figured out how to fix the oidentd problem. All you need to do, is make sure that grep znc /etc/passwd has its $home set to /etc/znc.
Thanks for a great tutorial
slap(Quote)
m!nus
2010/08/10
18:13
In order for .oidentd.conf to work in /etc/znc it must be set as your home dir: usermod -d /etc/znc znc
m!nus(Quote)
xSmurf
2010/10/17
21:08
Works great thanks! One issue I do have is that the log module doesn’t seem to work
xSmurf(Quote)
wildekek
2010/12/14
11:13
Nice! Works like a charm.
wildekek(Quote)
Rob Sharp
2011/10/19
00:11
I’ve noticed a couple of things after installing on Squeeze.
i) You need to add the following to the LSB section on the init script in order to run update-rc.d
# Required-Start: $all
# Required-Stop: $all
ii) I had to modify /etc/znc/configs/znc.conf with the new location of my znc.pem, as it was referencing the pem that was previously in my home directory.
Otherwise, the post is great!
Rob Sharp(Quote)
skaven
2011/10/25
22:07
Yes, indeed this is needed since squeeze needs LSB-Headers in the init-scripts. More information can be found here: http://wiki.debian.org/LSBInitScripts/DependencyBasedBoot
But I think you don’t need to add $all, since this could cause znc not to start when ANY service doesn’t start. I think you’ll only need the networking services.
skaven(Quote)
Allen
2012/01/05
09:49
Excellent guide, thanks!!
Allen(Quote)